function initArray( m)
	local array = {}
	for i = 1, m do
		array[i] = 0
	end
	return array
end

function totable( t, match)
     local cmd = {}
     if not match then match = "[^%s]+" end
     for word in string.gmatch( t, match) do
          table.insert( cmd, word)
     end
     return cmd
end 

--[[
Name : MMOD - Mafia Man mod
Creater : Mafia Man
Bugs : ?
Credits : ?
Contact : PM on UnrealSoftware

This is another version of my GMOD script but there no cars and many menu scripts :)
You can clear roofs objects and walls images with USE button!
Edit config.cfg and add a images but
If you draw or put in MMOD folder in gfx and you write in config it you must write in servertransfer too
if you want to play with other players !!!
]]--

mmodmax = 1000
mmod_id = initArray(mmodmax)
imgplayer = initArray(32)
mmod_imgpath = initArray(mmodmax)
mmod_type = initArray(mmodmax)
mmod_count = 0
mmod_select = initArray(32)
mmod_a = initArray(32)
mmod_r = initArray(32)
mmod_g = initArray(32)
mmod_b = initArray(32)
mmod_dir = initArray(32)
itm = initArray(32)
cwall = initArray(32)
cc = initArray(32)
vars = initArray(32)
allmax = 10000 --Max walls roofs and objects (if your comp is slow decrease it)
ro = 4 --Radius when object cleared (if you want bigger radius increase it)
wallmax = allmax
w = 0
wimg = initArray(wallmax)
wx = initArray(wallmax)
wy = initArray(wallmax)
tileonmax = allmax
to = 0
toimg = initArray(tileonmax)
tox = initArray(tileonmax)
toy = initArray(tileonmax)
objectsmax = allmax
o = 0
oimg = initArray(tileonmax)
ox = initArray(tileonmax)
oy = initArray(tileonmax)


function mmod_draw_tile( id, file, a, r, g, b, dir)
	img = image( file, ( player( id, "tilex") * 32 ) + 16, ( player( id, "tiley") * 32 ) + 16,0)
	imagepos(img,(player(id,"tilex")*32)+16,(player(id,"tiley")*32)+16,dir)
	imagecolor( img, r, g, b)
	imagealpha(img,a)
end

function mmod_draw_tile_on( id, file, a, r, g, b, dir)
	to = to + 1
	toimg[to] = image( file, ( player( id, "tilex") * 32 ) + 16, ( player( id, "tiley") * 32 ) + 16, 1)
	imagepos( toimg[to], ( player( id, "tilex") * 32 ) + 16, ( player( id, "tiley") * 32 ) + 16, dir)
	imagecolor( toimg[to], r, g, b)
	imagealpha( toimg[to], a)
	tox[to]=( player( id, "tilex") * 32) + 16
	toy[to]=( player( id, "tiley") * 32) + 16
end

function mmod_draw_object( id, file, a, r, g, b, dir)
	o = o + 1
	oimg[o] = image( file, player(id,"x"), player(id,"y"), 1)
	imagepos( oimg[o], player(id,"x"), player(id,"y"), dir)
	imagecolor( oimg[o], r, g, b)
	imagealpha( oimg[o], a)
	ox[o] = player( id, "x")
	oy[o] = player( id, "y")
end

function mmod_draw_wall( id, bid, x1, y1, file, a, r, g, b, dir)
	w = w + 1
	wx[w] = x1
	wy[w] = y1
	x2 = x1 * 32
	y2 = y1 * 32
	parse('spawnobject '..bid..' '..x1..' '..y1..' 0 0 '..player(id,"team")..' '..id)
	wimg[w] = image( file, x2 + 16, y2 + 16, 1)
	imagepos( wimg[w], x2 + 16, y2 + 16, dir)
	imagecolor( wimg[w], r, g, b)
	imagealpha( wimg[w], a)
end

function mmod_add( imgpath, type, a, r, g, b, dir)
	mmod_count = mmod_count + 1
	mmod_imgpath[ mmod_count] = imgpath
	mmod_type[ mmod_count] = type
	mmod_a[ mmod_count] = a
	mmod_r[ mmod_count] = r
	mmod_g[ mmod_count] = g
	mmod_b[ mmod_count] = b
	mmod_dir[ mmod_count] = dir
end

function ref_txt(id)
	local t
	if mmod_type[ mmod_select[id]] == 0 then t = "000255000Type : Wall" end
	if mmod_type[ mmod_select[id]] == 1 then t = "000255000Type : Floor" end
	if mmod_type[ mmod_select[id]] == 2 then t = "000255000Type : Object" end
	if mmod_type[ mmod_select[id]] == 3 then t = "000255000Type : Roof" end
	parse('hudtxt2 '..id..' 1 "'..t..'" 490 270 3')
end

addhook("team","mmod_team")
function mmod_team( id)
	vars[id] = 1
	mmod_select[id] = 1
	cwall[id] = ""
end

addhook("serveraction","mmod_serveraction")
function mmod_serveraction( id, b)
	if ( b==1 ) then
		if ( mmod_select[id] > 1 ) then
			mmod_select[id] = mmod_select[id] - 1
		end
	end
	if ( b==2 ) then
		if ( mmod_select[id] < mmod_count ) then
			mmod_select[id] = mmod_select[id] + 1
		end
	end
	if ( b==3 ) then
		if ( mmod_type[ mmod_select[id]] == 0) then
			cwall[id] = mmod_imgpath[ mmod_select[id]]
			cc[id] = mmod_select[id]
		end
		if ( mmod_type[ mmod_select[id]] == 1) then
			mmod_draw_tile( id, mmod_imgpath[ mmod_select[id]], mmod_a[ mmod_select[id]], mmod_r[ mmod_select[id]], mmod_g[ mmod_select[id]], mmod_b[ mmod_select[id]], mmod_dir[ mmod_select[id]])
		end
		if ( mmod_type[ mmod_select[id]] == 2) then
			mmod_draw_object( id, mmod_imgpath[ mmod_select[id]], mmod_a[ mmod_select[id]], mmod_r[ mmod_select[id]], mmod_g[ mmod_select[id]], mmod_b[ mmod_select[id]], mmod_dir[ mmod_select[id]])
		end
		if ( mmod_type[ mmod_select[id]] == 3) then
			mmod_draw_tile_on( id, mmod_imgpath[ mmod_select[id]], mmod_a[ mmod_select[id]], mmod_r[ mmod_select[id]], mmod_g[ mmod_select[id]], mmod_b[ mmod_select[id]], mmod_dir[ mmod_select[id]])
		end
	end
end

addhook("ms100","mmod_ms100")
function mmod_ms100()
	for i = 1, 32 do
		if ( player( i, "exists") ) then
			if vars[i] == 1 then
				freeimage( imgplayer[i])
				imgplayer[i] = image( mmod_imgpath[ mmod_select[i]],525,310,2)
				imagecolor( imgplayer[i], mmod_r[ mmod_select[i]], mmod_g[ mmod_select[i]], mmod_b[ mmod_select[i]])
				imagealpha( imgplayer[i], mmod_a[ mmod_select[i]])
				imagepos( imgplayer[i], 525, 310, mmod_dir[mmod_select[i]])
				ref_txt( i)
			end
		end
	end
end

addhook("buildattempt","mmod_buildattempt")
function mmod_buildattempt( id, bid, x, y)
	if ( bid > 2 ) and ( bid < 6 ) then
		if not ( cwall[id] == "" ) then mmod_draw_wall( id, bid, x, y, cwall[id], mmod_a[ cc[id]], mmod_r[ cc[id]], mmod_g[ cc[id]], mmod_b[ cc[id]], mmod_dir[ cc[id]]) end
		return 1
	end
	if ( bid == 1 or bid > 5) then
		if not ( bid == 20 or bid == 21 ) then
			parse('spawnobject '..bid..' '..x..' '..y..' 0 0 '..player( id, "team")..' '..id)
			return 1
		end
	end
end

addhook("spawn","mmod_spawn")
function mmod_spawn( id)
	parse('equip '..id..' 74')
end

addhook("use","mmod_use")
function mmod_use( id, ev)
	if ev==0 then
		for i=1, allmax do
			local x, y, tx, ty
			x = player( id, "x")
			y = player( id, "y")
			tx = player( id, "tilex")
			ty = player( id, "tiley")
			if x >= ( ox[i] - ro) and x <= ( ox[i] + ro) and y >= ( oy[i] - ro) and y <= ( oy[i] + ro) then
				freeimage( oimg[i])
			end
			if tx == wx[i] and ty == wy[i] then
				freeimage( wimg[i])
			end
			if tx == tox[i] and ty == toy[i] then
				freeimage( toimg[i])
			end
		end
		return 1
	end
end

addhook("say","mmod_say")
function mmod_say( i, t)
	txt=totable( t)
	if txt[1]=="!img" then
		if txt[2] ~= nil then
			if tonumber( txt[2]) <= mmod_count then
				mmod_select[i] = tonumber( txt[2])
			else
				msg2( i, "255000000Theres only : "..mmod_count.." tiles !")
			end
		else
			msg2( i, "255000000Wrong parametrs !")
		end
		return 1
	end
	if txt[1]=="!item" then
		if txt[2] ~= nil then
			itm[i]=txt[2]
		else
			msg2( i, "255000000Wrong parametrs !")
		end
		return 1
	end
end

addhook("drop","mmod_attack2")
function mmod_attack2( id, t, i)
	if i==74 then
		parse('spawnitem '..itm[id]..' '..player(id,"tilex")..' '..player(id,"tiley"))
		return 1
	end
end

dofile('sys/lua/mmod_config.cfg')